import type { _NSArray } from "../Foundation/NSArray.js";
import type { _NSObject } from "../Foundation/NSObject.js";
import type { _NSString } from "../Foundation/NSString.js";
export declare class _ODAttributeMap extends _NSObject {
    static alloc(): _ODAttributeMap;
    static new(): _ODAttributeMap;
    init(): _ODAttributeMap;
    /**
     * @method attributeMapWithValue: @abstract Returns an initialized and autoreleased ODAttributeMap object with the given value mapped. @discussion Returns an initialized and autoreleased ODAttributeMap object with the given value mapped.
     */
    static attributeMapWithValue$(value: _NSString): _ODAttributeMap;
    /**
     * @method attributeMapWithStaticValue: @abstract Returns an initialized and autoreleased ODAttributeMap object with the given static value. @discussion Returns an initialized and autoreleased ODAttributeMap object with the given static value.
     */
    static attributeMapWithStaticValue$(staticValue: _NSString): _ODAttributeMap;
    /**
     * @method setStaticValue: @abstract Sets a static value that will always be returned for this mapping. @discussion Sets a static value that will always be returned for this mapping, i.e., "20".
     */
    setStaticValue$(staticValue: _NSString): void;
    /**
     * @method setVariableSubstitution: @abstract Sets a variable substitution-based value. @discussion Value should be using the syntax '$native$' for all substited values. For example, to form a home directory using the "cn" of an LDAP record, substitution could be done with "/home/$cn$".
     */
    setVariableSubstitution$(variableSubstitution: _NSString): void;
    /** Custom function to be used when querying the attribute */
    customQueryFunction(): _NSString;
    setCustomQueryFunction$(value: _NSString): void;
    /** Custom function to be used when translating the result for the client */
    customTranslationFunction(): _NSString;
    setCustomTranslationFunction$(value: _NSString): void;
    /** Attributes required for the custom functions */
    customAttributes(): _NSArray;
    setCustomAttributes$(value: _NSArray): void;
    /**
     * The value used for the mapping. Static, variable substitution and native are all represented
     */
    value(): _NSString;
    setValue$(value: _NSString): void;
}
